
{$A+}   { Align data }
{$B-}   { Boolean evaluation }
{$E+}   { 80x87 emulator }
{$F-}   { Force FAR calls }
{$G+}   { 80286 code }
{$I-}   { I/O checking }
{$K-}   { Smart Callbacks }
{$N-}   { 80x87 code }
{$O-}   { Overlays allowed }
{$P-}   { Open parameters }
{$T-}   { Typed pointers }
{$V-}   { String VAR checking }
{$W-}   { Windows stack frame for real mode }
{$X+}   { Extended syntax }

{$IFDEF DEBUG}
    {$D+}   { Debug information }
    {$L+}   { Local symbols }
    {$Q+}   { Overflow checking }
    {$R+}   { Range checking }
    {$S+}   { Stack checking }
    {$Y+}   { Symbol reference information }
{$ELSE}
    {$D-}   { Debug information }
    {$L-}   { Local symbols }
    {$Q-}   { Overflow checking }
    {$R-}   { Range checking }
    {$S-}   { Stack checking }
    {$Y-}   { Symbol reference information }
{$ENDIF}

{$C Moveable Demandload Discardable} { Code Segment attributes }

{$M 4096,4096}

PROGRAM DoBeep;

USES WinTypes, WinProcs, WinCrt,
     PatchTpw;

CONST
    cDelay = 3000; { Delay for 3 seconds }

(* ---- *)

PROCEDURE MyYield;
{ Yield control to other Windows apps }

VAR
    pToMsg : PMsg;
    wResult : Word;

BEGIN
    New (pToMsg);

    WHILE (PeekMessage (pToMsg^, 0, 0, 0, pm_Remove)) DO
    BEGIN
        IF (pToMsg^.Message = wm_Quit) THEN
        BEGIN
            wResult := pToMsg^.wParam;
            Dispose (pToMsg);
            Halt (wResult);
        END; { if }

        TranslateMessage (pToMsg^);
        DispatchMessage (pToMsg^);
    END; { while }

    Dispose (pToMsg);
END; { MyYield }

(* ---- *)

PROCEDURE Delay (wTime: Word);
{ Delay for wTime milliseconds }

VAR
    lStartTime : LongInt;

BEGIN
    lStartTime := GetTickCount;

    WHILE ((GetTickCount - lStartTime) < wTime) DO
        MyYield;
END; { Wait }

(* ---- *)

PROCEDURE CallMessageBeep (wBeepType: Word);
{ Call the MessageBeep procedure }

BEGIN
    Writeln ('MessageBeep (', wBeepType, ')');
    MessageBeep (wBeepType);
    Delay (cDelay);
END; { CallMessageBeep }

(* ---- *)

BEGIN { DoBeep }
    Patch;
    Writeln ('MessageBeep patched (MessageBeep (0) doesn''t work)');

    CallMessageBeep (Word (-1));
    CallMessageBeep (0);
    CallMessageBeep (mb_IconStop);
    CallMessageBeep (0);
    CallMessageBeep (mb_IconExclamation);
    CallMessageBeep (0);
    CallMessageBeep (mb_IconHand);
    CallMessageBeep (0);
    CallMessageBeep (mb_IconAsterisk);
    CallMessageBeep (0);
    CallMessageBeep (mb_IconQuestion);
    CallMessageBeep (0);
    CallMessageBeep (Word (-1));

    UnPatch;
    Writeln ('MessageBeep unpatched (MessageBeep (0) does work)');

    CallMessageBeep (0);
    CallMessageBeep (0);
    CallMessageBeep (0);

    Patch;
    Writeln ('MessageBeep patched (MessageBeep (0) doesn''t work)');

    CallMessageBeep (0);
    CallMessageBeep (0);
    CallMessageBeep (0);

    UnPatch;
    Writeln ('MessageBeep unpatched (MessageBeep (0) does work)');

    Delay (3000);

    DoneWinCrt;
END. { DoBeep }
